<template>
	<v-row class="search-box" align="center" no-gutters>
		<!-- <v-col v-if="label" cols="2"> -->
		<v-col v-if="label" :cols="labelCols">
			<label for="" class="search-box-label">
				<v-icon x-small color="primary" class="mr-1">mdi-record-circle</v-icon>
				{{ label }}
			</label>
		</v-col>
		<v-col :cols="label ? textCols : ''">
			<!-- <v-col :cols="label ? 9 : ''"> -->
			<!-- :value="textfield" -->
			<v-text-field
				readonly
				v-model="selectValue"
				append-icon="mdi-magnify"
				class="v-input__custom"
				@click="dialog = !dialog"
				:hide-details="true"
				outlined
			></v-text-field>
		</v-col>

		<!-- <v-row justify="center"> -->
		<v-dialog
			ref="popModal"
			v-model="dialog"
			width="600"
			overlay-color="#000"
			overlay-opacity="0.8"
			scrollable
		>
			<!-- <template v-slot:activator="{ on, attrs }">
        <v-btn color="primary" dark v-bind="attrs" v-on="on">공정/설비</v-btn>
      </template> -->
			<v-card :height="height">
				<v-card-title class="d-flex align-center justify-space-between">
					<span class="custom-title-4">{{
						this.eqpmYn ? '공정/설비' : '공정'
					}}</span>
					<v-btn icon tile :ripple="false" @click="dialog = !dialog">
						<v-icon>mdi-close</v-icon>
					</v-btn>
				</v-card-title>
				<div class="pa-5">
					<!-- <v-text-field label="위치정보 선택"></v-text-field> -->
					<v-row align="center" no-gutters>
						<v-col v-if="label" cols="3">
							<label for="" class="search-box-label">
								<v-icon x-small color="primary" class="mr-1"
									>mdi-record-circle</v-icon
								>
								위치정보 선택
							</label>
						</v-col>
						<v-col :cols="label ? 6 : ''">
							<!-- :value="textfield" -->
							<v-text-field
								append-icon="mdi-magnify"
								class="v-input__custom"
								outlined
								:hide-details="true"
								v-model="searchWord"
								@keyup.enter="typeEnterKey"
							></v-text-field>
						</v-col>
						<v-spacer></v-spacer>
						<v-col cols="3" class="text-right">
							<v-btn :ripple="false" icon tile @click="btnTreeExpand()">
								<!-- {{ treeExpand }} -->
								<v-icon
									size="30"
									v-text="treeExpandAll ? 'mdi-chevron-up' : 'mdi-chevron-down'"
								></v-icon>
							</v-btn>
							<!-- <v-btn color="primary" dark>펼치기</v-btn> -->
							<!-- <v-btn color="primary" dark>접기</v-btn> -->
							<!-- <v-btn :ripple="false">초기화</v-btn> -->
							<v-btn v-if="searchParam.isMulti" :ripple="false" @click="reset()"
								>초기화</v-btn
							>
							<v-btn
								v-if="!searchParam.isMulti"
								:ripple="false"
								@click="search()"
								>검색</v-btn
							>
							<!-- as-is 롤 봐도 초기화가 하는 기능을 모르겠음.. -->
						</v-col>
					</v-row>
				</div>
				<v-divider></v-divider>
				<div :style="{ height: 'calc(100% - 213px)' }">
					<div ref="treeGridParent" class="h100 py-3">
						<component
							:ref="'treeGrid' + parentPrgmId"
							:is="loadGrid && dialog ? 'Grid' : null"
							:gridName="gridNameTree"
							:dataPath="searchParam.modalData.selectFtnPlcListTree"
							:parentPrgmId="parentPrgmId"
							@getRowsData="getRowData"
							@dblClick="setUpdate()"
						/>
					</div>
					<!-- <component
            :is="ftnPlcListTreeData.length > 0 ? 'Tree' : null"
            :tree-data="ftnPlcListTreeData"
          /> -->
				</div>
				<v-card-actions class="pa-5 d-flex align-center justify-center">
					<v-btn :ripple="false" @click="setUpdate()">확인</v-btn>
					<v-btn :ripple="false" @click="dialog = false">닫기</v-btn>
					<!-- <v-btn
            color="green darken-1"
            text
            @click="dialog = false"
          >
            Disagree
          </v-btn>
          <v-btn
            color="green darken-1"
            text
            @click="dialog = false"
          >
            Agree
          </v-btn> -->
				</v-card-actions>
			</v-card>
		</v-dialog>
	</v-row>
</template>

<script>
import { mapState, mapMutations, mapActions } from 'vuex';
import Grid from '~/components/common/Grid';
import Utility from '~/plugins/utility';

export default {
	props: {
		parentPrgmId: {
			type: String,
			require: true,
			default: '비교대상 최대(20개)',
		},
		label: {
			type: String,
			require: true,
			default: '공정/설비',
		},
		labelCols: {
			type: Number,
			require: false,
			default: 4,
		},
		textCols: {
			type: Number,
			require: false,
			default: 8,
		},
		height: {
			type: Number,
			default: 713,
		},
		eqpmYn: {
			type: Number,
			require: false,
			default: 1,
		},
	},
	components: {
		Grid,
		// Tree
	},
	data() {
		return {
			labelPrepend: true,

			myModalKey: 'selectFtnPlcListTree',
			gridNameTree: 'treeGrid',
			loadGrid: false,

			dialog: false,
			treeData: [], // 리턴받은 원본 트리 데이터
			modalDataKey: 'modalData',
			treeExpandAll: true,
			activeRowData: {},
			checkedRowDataList: [],

			searchWord: '',

			// isUpdate: false
			// ftnPlcListTreeData: []
		};
	},
	computed: {
		...mapState({
			// searchParam: state => state.pageData,
			searchParam(state) {
				return state.pageData[this.parentPrgmId];
			},
			isDarkMode: 'isDarkMode',
		}),
		chkDialog() {
			// 모달 열기/닫기 값
			if (this.searchParam.isMulti == false) {
				// delete this.$store.state.pageData[this.parentPrgmId]['modalData'][this.myModalKey].treeGrid.option.rowHeaders[0] = {};
				this.$store.state.pageData[this.parentPrgmId]['modalData'][
					this.myModalKey
				].treeGrid.option.rowHeaders = [];
			} else {
				this.$store.state.pageData[this.parentPrgmId]['modalData'][
					this.myModalKey
				].treeGrid.option.rowHeaders = [{ type: 'check' }];
			}
			return this.dialog;
		},
		selectValue() {
			// 선택된 공장/설비 값
			const temp = [];
			const facData = this.searchParam.isMulti
				? this.searchParam.facInfoList
				: this.searchParam.facInfo;
			if (Array.isArray(facData)) {
				if (facData.length > 0) {
					for (const item of facData) {
						temp.push(item.eccNm);
					}
				}
			} else {
				return facData.path === undefined ? facData.eccNm : facData.path;
			}
			return temp.join();
		},
		treeExpand() {
			return this.treeExpandAll ? '접기' : '펼치기';
		},
	},
	watch: {
		async chkDialog(val) {
			if (val) {
				await this.getTreeData();
			}
		},
	},

	beforeCreate() {
		this.$store.commit('setPageData', {
			modalData: { selectFtnPlcListTree },
		});
	},
	created() {
		this.init();
		if (this.searchParam.isMulti == true) {
			this.setPageData({
				facInfoList:
					localStorage.getItem(this.parentPrgmId + 'CheckedRow') != null
						? JSON.parse(localStorage.getItem(this.parentPrgmId + 'CheckedRow'))
						: {},
			});
		} else {
			this.setPageData({
				facInfo:
					localStorage.getItem(this.parentPrgmId + 'CheckedRow') != null
						? JSON.parse(localStorage.getItem(this.parentPrgmId + 'CheckedRow'))
						: {},
			});
		}
	},
	methods: {
		...mapMutations({
			setPageData: 'setPageData',
			setModalGridData: 'setModalGridData',
			setModalGridColumn: 'setModalGridColumn',
			setModalGridOption: 'setModalGridOption',
		}),
		...mapActions({
			postApiReturn: 'modules/list/postApiReturn',
			setTree: 'modules/list/setTree',
		}),
		init() {
			this.activeRowData = {};
			this.gridInit();
		},
		// 공정/설비 트리 그리드 세팅
		gridInit() {
			const treeGridHeight = 490;
			this.setModalGridColumn({
				modalKey: this.myModalKey,
				gridKey: this.gridNameTree,
				modalDataKey: this.modalDataKey,
				value: [{ header: '위치정보', name: 'eccNm' }],
			});
		},
		// 공정/설비 조회
		async getTreeData() {
			this.loadGrid = false;
			const res = await this.postApiReturn({
				apiKey: 'selectFtnPlcListTree',
				resKey: 'ftnPlcTreeDatas',
				sendParam: {
					blocId:
						this.searchParam.blocMstrList.length > 0
							? this.searchParam.blocMstrList[this.searchParam.blocId].blocId
							: this.searchParam.blocId, //"BL0001",
					roiId: this.searchParam.energyList[this.searchParam.energyCd].cd, // "MTT00001" // 전력 코드 고정
					eqpmYn: this.eqpmYn,
					search: this.searchWord,
				},
			});

			let myOptionsTree = {
				treeColumnOptions: {
					name: 'eccNm',
					useIcon: true,
				},
				scrollX: false,
			};
			if (this.searchParam.isMulti) {
				myOptionsTree['rowHeaders'] = [{ type: 'checkbox' }];
				myOptionsTree['rowHeight'] = 'auto'; // checkbox와 그리드 높이 같게
				myOptionsTree['treeColumnOptions']['useCascadingCheckbox'] = false;
			}

			this.setModalGridOption({
				modalKey: this.myModalKey,
				gridKey: this.gridNameTree,
				modalDataKey: this.modalDataKey,
				// value: myOptionsTree
				value: Object.assign(
					Utility.defaultGridOption(
						this.$refs.treeGridParent.offsetHeight - 60,
					),
					myOptionsTree,
				),
			});

			// this.treeData = res;
			// const ROOT = res[0].plcCd;
			const setTreeData = await this.setTree({
				gridKey: this.gridNameTree,
				treeKey: 'ECC_ID',
				value: res.map(item => ({
					...item,
					eccNm: item.eccNm,
				})),
			});
			// this.treeData = setTreeData;
			this.setModalGridData({
				modalKey: this.myModalKey,
				gridKey: this.gridNameTree,
				modalDataKey: this.modalDataKey,
				value: setTreeData.ROOT || [],
			});
			this.loadGrid = true;

			this.$nextTick(() => {
				if (this.searchParam.isMulti) {
					this.setGridCheckedRows();
				}
			});
		},
		setGridCheckedRows() {
			this.checkedRowDataList =
				this.searchParam.facInfoList.length > 0
					? this.searchParam.facInfoList
					: [];

			if (this.checkedRowDataList.length > 0) {
				for (var i = 0; i < this.checkedRowDataList.length; i++) {
					this.$refs['treeGrid' + this.parentPrgmId].checkEvt(
						this.checkedRowDataList[i],
						this.$refs['treeGrid' + this.parentPrgmId],
					);
				}
			}
		},
		// 공정/설비 트리 row 클릭이벤트
		getRowData(data) {
			//this.activeRowData = data;

			if (this.searchParam.isMulti) {
				if (data._attributes.checked) {
					this.$refs['treeGrid' + this.parentPrgmId].uncheckEvt(
						data,
						this.$refs['treeGrid' + this.parentPrgmId],
					);
				} else {
					this.$refs['treeGrid' + this.parentPrgmId].checkEvt(
						data,
						this.$refs['treeGrid' + this.parentPrgmId],
					);
				}
			} else {
				this.activeRowData = data;
			}
		},
		setUpdate() {
			if (this.searchParam.isMulti) {
				this.checkedRowDataList = this.$refs[
					'treeGrid' + this.parentPrgmId
				].getCheckedRowsEvt();
				if (this.checkedRowDataList.length < 20) {
					this.dialog = false;
					this.setPageData({ facInfoList: this.checkedRowDataList });
					localStorage.setItem(
						this.parentPrgmId + 'CheckedRow',
						JSON.stringify(this.searchParam.facInfoList),
					);
				} else {
					alert('비교대상이 20개를 초과하였습니다.');
				}
			} else {
				this.dialog = false;
				this.setPageData({ facInfo: this.activeRowData });
				localStorage.setItem(
					this.parentPrgmId + 'CheckedRow',
					JSON.stringify(this.searchParam.facInfo),
				);
			}
		},
		// 공정/설비 트리 접기/펼치기
		btnTreeExpand() {
			this.treeExpandAll = !this.treeExpandAll;
			if (this.treeExpandAll)
				this.$refs['treeGrid' + this.parentPrgmId].expandAll();
			else this.$refs['treeGrid' + this.parentPrgmId].collapseAll();
		},
		reset() {
			for (
				var i = 0;
				i < this.$refs['treeGrid' + this.parentPrgmId].getData().length;
				i++
			) {
				this.$refs['treeGrid' + this.parentPrgmId].uncheckEvt(
					this.$refs['treeGrid' + this.parentPrgmId].getData()[i],
					this.$refs['treeGrid' + this.parentPrgmId],
				);
			}
		},
		search() {
			this.getTreeData();
		},
		typeEnterKey() {
			this.getTreeData();
		},
	},
};

const selectFtnPlcListTree = {
	treeGrid: {
		data: [],
		column: [], // myColumns,
		option: {}, // myOptions
	},
};
</script>
<style lang="scss" scoped>
::v-deep {
	.v-dialog {
		overflow-y: hidden !important;
	}

	.tui-grid-table-container {
		.tui-grid-table {
			border-right-style: solid !important;
			border-right-color: rgba(255, 255, 255, 0.1) !important;
		}
	}

	.tui-grid-cell.tui-grid-cell-has-tree
		.tui-grid-tree-extra-content
		+ .tui-grid-cell-content:before {
		content: none !important;
	}

	.tui-grid-tree-icon {
		margin-left: -21px !important;
	}
}

@each $theme in dark, light {
	.v-application.#{$theme}-mode {
		.v-dialog {
			.v-card {
				&__title {
					color: map-deep-get($color, 'white', '0');
					@if $theme == dark {
						background-color: #2d3355;
						.v-btn {
							background-color: #2d3355;
						}
					} @else {
						background-color: #3f4d7d;
						.v-btn {
							background-color: #3f4d7d;
						}
					}
				}
			}
		}
	}
}
</style>
